!
! This versione exists only to set nmembersloc, which ought to be set
! programmatically anyway.  -Andy Jacobson
!

!### macros #####################################################
#define TRACEBACK write (gol,'("in ",a," (",a,", line",i5,")")') rname, __FILE__, __LINE__; call goErr
#define IF_NOTOK_RETURN(action) if (status/=0) then; TRACEBACK; action; return; end if
#define IF_ERROR_RETURN(action) if (status> 0) then; TRACEBACK; action; return; end if
                                                                                                                                                     
#include "tm5.inc"
!#################################################################

module emission_common

  use GO,				only : gol, goErr, goPr, goLabel
  use Dims,            	      		only : nlon360,nlat180


  ! This structure is used to hold emission module results and also
  ! to hold mean fluxes.

  type field_1x1
     real*8, dimension(nlon360,nlat180)			:: surf
     integer						:: n
     real*8						:: wda
  end type field_1x1


  ! This particular parameter structure is appropriate for a map of scaling factors.

  type enkf_parms
     real, dimension(nlon360,nlat180)			:: surf
  end type enkf_parms

  character(len=1024)					:: EmisInputDir
  character(len=2048)					:: FluxOutFile = ''
  integer						:: nmembersloc=5 ! for inverse only


  ! Each member of co2_bio contains a (scaled) flux field.  Integer n unused.

  type(field_1x1), dimension(:), allocatable,target,save	:: co2_bio
  type(field_1x1), dimension(:), allocatable,target,save	:: co2_ocn
  type(field_1x1), dimension(:), allocatable,target,save	:: co2_ff
  type(field_1x1), dimension(:), allocatable,target,save	:: co2_fires

  ! Each member of enkf_parms contains the set of parameters for a given ensemble member.

  type(enkf_parms),dimension(:), allocatable		:: parms

  ! 1x1 degree global map of regions.  Maps scaling-factor parameters to geographic location.
  ! not using field_1x1 structure since values are integers
  integer,dimension(:,:), allocatable			:: region_map

  private

  public						:: field_1x1, enkf_parms
  public						:: co2_bio
  public						:: co2_ocn
  public						:: co2_ff
  public						:: co2_fires
  public						:: parms
  public						:: region_map

  public						:: EmisInputDir
  public						:: nmembersloc

  
  character(len=*), parameter				:: mname = 'emission_common'
  private						:: mname

contains

end module emission_common
